<?php

class GS_API_CUSTOM extends GS_API{

	public function __construct($objCore){
		parent::__construct($objCore);
	}

	/*
	 *
	 * Diese Datei in class.api.custom.php umbenennen; danach wird sie durch GSALES
	 * anstelle der ursprünglichen API eingebunden und verwendet.
	 *
	 * Beispielhafte Verwendung:
	 *
		public function getCustomer($intId){
			// [...] eigener code
			$res =  parent::getCustomer($intId);
			// [...] eigener code
			return $res;
		}

		public function getCustomers($arrFilter='', $arrSort='', $intLimit=100, $intOffset=0){
			// [...] eigener code
			$res =  parent::getCustomers($arrFilter, $arrSort, $intLimit, $intOffset);
			// [...] eigener code
			return $res;
		}

		public function getCustomersCount($arrFilter=''){
			// [...] eigener code
			return parent::getCustomersCount($arrFilter);
		}
	*
	*
	* Folgende Methoden können überlagert werden:
	*
		// Customers section
		public function getCustomer($intId){}
		public function getCustomers($arrFilter='', $arrSort='', $intLimit=100, $intOffset=0){}
		public function getCustomersCount($arrFilter=''){}
		public function getCustomersRepayable(){}
		public function createCustomer($arrData){}
		public function updateCustomer($intId, $arrData){}
		public function updateCustomerProposal($intId, $arrData){}
		public function deleteCustomer($intId){}
		public function doCustomerFrontendLogin($strCustomerNoOrEmail, $strMD5Password){}
		public function enableCustomerFrontendLogin($strCustomerNoOrEmail){}
		public function enableCustomerFrontendLoginById($intId){}
		public function disableCustomerFrontendLogin($strCustomerNoOrEmail){}
		public function disableCustomerFrontendLoginById($intId){}
		public function changeCustomerFrontendPassword($intCustomerId, $strMD5Password){}
		public function customerFrontendPasswordLost($strCustomerNoOrEmail){}

		// Documents section
		public function getCustomerDocument($intDocumentId){}
		public function getCustomerDocuments($arrFilter='', $arrSort='', $intLimit=100, $intOffset=0){}
		public function getDocumentFile($intDocumentId){}

		// Article section
		public function getArticle($intId){}
		public function getArticles($arrFilter='', $arrSort='', $intLimit=100, $intOffset=0){}
		public function getArticlesCount($arrFilter=''){}
		public function createArticle($arrData){}
		public function updateArticle($intId, $arrData){}
		public function deleteArticle($intId){}

		// Queue section
		public function getQueueEntry($intId){}
		public function getQueueEntries($arrFilter='', $arrSort='', $intLimit=100, $intOffset=0){}
		public function getQueueEntriesCount($arrFilter=''){}
		public function createQueueEntry($arrData){}
		public function updateQueueEntry($intId, $arrData){}
		public function deleteQueueEntry($intId){}
		public function setQueueEntryState($intId, $intState){}
		public function createInvoiceFromQueueForCustomer($intId){}
		public function createInvoicesFromQueueForAll(){}

		// Rights & Roles section
		public function getAvailableRoles(){}
		public function getRolesOfUser($intUserId){}
		public function addRoleToUser($intRoleId, $intUserId){}
		public function removeRoleFromUser($intRoleId, $intUserId){}

		// User section
		public function getUser($intUserId){}
		public function getUsers($arrFilter='', $arrSort='', $intLimit=100, $intOffset=0){}
		public function getUsersCount($arrFilter){}
		public function createUser($arrData){}
		public function updateUser($intUserId, $arrData){}
		public function deleteUser($intUserId){}
		public function lockUser($intUserId){}
		public function unlockUser($intUserId){}

		// Mixed section (invoice, offers, refunds, contracts, sales, deliveries)
		public function getInvoice($intId, $strInvoiceArea='subinvoice'){}
		public function getInvoices($arrFilter='', $arrSort='', $intLimit=100, $intOffset=0, $strInvoiceArea='subinvoice'){}
		public function getInvoicesCount($arrFilter, $strInvoiceArea='subinvoice'){}
		public function setInvoiceState($intId, $intState, $strInvoiceArea='subinvoice'){}
		public function createInvoice($arrData, $strInvoiceArea='subinvoice'){}
		public function updateInvoice($intInvoiceId, $arrData, $strInvoiceArea='subinvoice'){}
		public function deleteInvoice($intInvoiceId, $strInvoiceArea='subinvoice'){}
		public function createInvoiceForCustomer($intCustomerId, $strInvoiceArea='subinvoice'){}
		public function createInvoicePosition($intId, $arrData, $strInvoiceArea='subinvoice'){}
		public function deleteInvoicePosition($intPosId, $intInvoiceId, $strInvoiceArea='subinvoice'){}
		public function updateInvoicePosition($intPosId, $intInvoiceId, $arrData, $strInvoiceArea='subinvoice'){}
		public function addInvoiceToMailspool($intInvoiceId, $strInvoiceArea='subinvoice'){}
		public function getInvoicePDF($intInvoiceId, $strInvoiceArea='subinvoice'){}

		// Contracts section
		public function setContractState($intId, $intState){}
		public function createContractForCustomer($intCustomerId, $arrData){}
		public function updateContract($intInvoiceId, $arrData){}
		public function updateContractEndDate($intInvoiceId, $intMonth, $intYear){}
		public function getContractsRepayable(){}
		public function processContractsRepayable($intCustomerId=''){}
		public function processContractRepayableNow($intInvoiceId){}

		// Mailspool section
		public function sendMailspool(){}
		public function getMailspoolEntry($intId){}
		public function getMailspoolEntries($arrFilter='', $arrSort='', $intLimit=100, $intOffset=0){}
		public function getMailspoolEntriesCount($arrFilter=''){}
		public function duplicateMailspoolEntry($intId){}
		public function setMailspoolSendApprovalForEntry($intId){}
		public function setMailspoolReadForEntry($intId){}
		public function removeMailspoolSendApprovalForEntry($intId){}
		public function createMailspoolEntry($arrData){}
		public function updateMailspoolEntry($intId, $arrData){}
		public function deleteMailspoolEntry($intId){}

		// Newsletter section
		public function getNewsletter($intId){}
		public function getNewsletterRecipients($intId){}
		public function createNewsletter($arrData){}
		public function updateNewsletter($intId, $arrData){}
		public function deleteNewsletter($intId){}
		public function getNewsletters($arrFilter='', $arrSort='', $intLimit=100, $intOffset=0){}
		public function getNewslettersCount($arrFilter=''){}
		public function addNewsletterRecipient($intId, $arrData){}
		public function addNewsletterRecipientByCustomerId($intNewsletterId, $intCustomerId){}
		public function removeNewsletterRecipient($intId){}
		public function spoolNewsletter($intId){}

		// Misc
		public function getConfigurationValue($strValue){}

	*
	*
	*/

}