/*
 * GSALES
 * http://www.gsales.de
 *
 * Author: Gedankengut GbR
 */

/////
// Catch script errors
/////
window.onerror = function(msg, url, linenumber){
	$('#notifications').append('<div class="alert alert-error"><p>JavaScript in ' + url.substr(url.lastIndexOf("/")+1,url.length) + ' (Zeile ' + linenumber + '): <em>' + msg + '</em></p></div>');
};

/////
// Center dialogs on resize
/////
window.onresize = function(){
	if(navigator.userAgent.toLowerCase().indexOf('ipad') == -1) {
		$("#dialog-confirm:visible, #dialog-form:visible, #aiibox:visible").dialog({ position: 'center' });
	}
};

/////
// DOM ready
/////
$(document).ready(function(){

	/////
	// Ajax setup
	/////
    $.ajaxSetup({
        beforeSend: function() {
            $('#ajaxLoading').show();
        },
        complete: function() {
            $('#ajaxLoading').hide();
            $('body').trigger('gsalesAjaxSuccess');
        },
        success: function() {
            $('#ajaxLoading').hide();
        }
    });

    $.ajaxPrefilter(function (options, originalOptions, jqXHR) {
        if ( options.crossDomain ) options.contents.script = false;
        options.data = $.param($.extend(originalOptions.data, { gsref: window.location.href }));
    });

	/////
	// Notification icons
	/////
	$('div.success span, div.success p').prepend('<span aria-hidden="true" data-icon="&#xe006;"></span>');
	$('div.notice span, div.notice p').prepend('<span aria-hidden="true" data-icon="&#xe010;"></span>');
	$('div.error span, div.error p').prepend('<span aria-hidden="true" data-icon="&#xe01a;"></span>');

	/////
	// Oversize content width
	/////
	if($('#tabletwo').length > 0) {
		var tempWidth = $('html').width();
		// width
		var elWrap = $('#wrap');
		var requiredWidth = $('#cntContent').width() + 190;
		var wrapWidth = elWrap.width();
		if(requiredWidth-2 > wrapWidth) {
			elWrap.css('min-width', (requiredWidth + 155 + 'px') );
			$('html').css('min-width', (requiredWidth + 155 + 'px') );
			$('#header').css('width', (tempWidth + 'px') );
			$('#header').css('margin-left', (0 + 'px') );
			$('#header').css('margin-right', (0 + 'px') );
		}
	}

	/////
	// Form placeholder fallback
	/////
	if($.browser.msie){
		if(parseInt($.browser.version, 10) < 10) {
			$('[placeholder]').focus(function() {
				var input = $(this);
				if (input.val() == input.attr('placeholder')) {
					input.val('');
					input.removeClass('placeholder');
				}
			}).blur(function() {
					var input = $(this);
					if (input.val() == '' || input.val() == input.attr('placeholder')) {
						input.addClass('placeholder');
						input.val(input.attr('placeholder'));
					}
			}).blur().parents('form').submit(function() {
				$(this).find('[placeholder]').each(function() {
					var input = $(this);
					if (input.val() == input.attr('placeholder')) {
						input.val('');
					}
				})
			});
		}
	}
	
	/////
	// Autocomplete with filter
	/////
	$('input[data-ac]').each(function(){

		var ref = $(this);
		var refVal = ref.val();
		var ac = ref.data('ac');

		$.ajax({
			url: gsPath+"index.php?p=jajax&t=sugg&r="+ac+"&q=",
			type: 'POST',
			dataType: 'json',
			success: function(data){
				var res = [];
				var boolInArray = false;
				res.push({id: null, text: 'eigene Eingabe'});
				$.map(data, function(item){
					res.push({id: item.value, text: item.value});
					if(refVal == item.value) boolInArray = true;
				});
				if(boolInArray || refVal == ''){
					var strWidth = 'element';
					if(ac == 'custort' || ac == 'custland') strWidth = '220px';
					function initSelect(){
						// select field
						var el = ref.select2({
							initSelection: $(ref).val(),
							data: res,
							width: strWidth,
							formatNoMatches: function () { return 'eigene Eingabe'; }
						});
						// destroy for own value
						el.on('change', function(e){
							if(e.val == '') el.select2('destroy');
							ref.focus();
							// init select2 for empty values
							ref.blur(function(){
								if(ref.val() == ''){
									ref.val(refVal);
									initSelect();
								}
							});
						});
						// show default value
						if(refVal != '') setSelectCaption(ref, refVal);
						// round corners
						$('.select2-choices').addClass('ui-corner-all');
						// set custom values by return
						var tempSelect = ref.select2('container');
						var tempSearchInput = $('.select2-search input', tempSelect);
						var tempResults = $('.select2-results', tempSelect);
						$(tempSearchInput).on('keyup', function(e){
							if(e.keyCode == 13){
								if($('.select2-no-results', tempResults).length > 0){
									var tempValue = $(tempSearchInput).val();
									el.select2('close').select2('destroy');
									ref.val(tempValue);
									ref.focus();
								}
							}
						});
					}
					initSelect();
				}
			}
		});
	});

	/////
	// Customer autocomplete
	/////
	$('input[data-customercomplete]').each(function(){

		var ref = $(this);

		var el = ref.select2({
			placeholder: 'Kunde wählen',
			allowClear: true,
			minimumInputLength: 1,
			width: 'element',
			ajax: {
				url: gsPath+'index.php',
				dataType: 'json',
				quietMillis: 100,
				data: function (term, page) {
					return {
						p: 'jajax',
						t: 'sugg',
						r: 'customers',
						q: term,
						page_limit: 10
					};
				},
				results: function (data, page) {
					var res = [];
					$.map(data, function(item){
						res.push({ id: item.id, text: item.value + ' (' + item.info + ')' });
					});
					return { results: res };
				}
			}
		});
		// update hidden field values in customer form
		el.on('change', function(e) {
			$('input[name^="customerid"]').val(e.val);
			// autofill customer data if available
			if(typeof suggCustomerFlush == 'function' && e.val == '') {
				suggCustomerFlush();
			} else if(typeof suggCustomerPopulate == 'function' && e.val != '') {
				suggCustomerPopulate(e.val);
			}
		});
		// set caption on load
		setSelectSearchCaption(ref, $(this).data('customercompletecaption'));
	});

	/////
	// Multiple tags ajax input field
	/////
	if($('.tagfield').length > 0){
		$('.tagfield').each(function(){
			var gsSection = $(this).data('section');
			$.ajax({
				url: gsPath+'ajx/index.php?p=taglist',
				type: 'POST',
				dataType: 'json',
				data: { dbtable: gsSection },
				success: function(data){
					var taglist = data.tags.split(',');
					$('.tagfield').select2({
						tags: taglist,
						tokenSeparators: [',', ' '],
						width: 'element',
						placeholder: 'Kategorien wählen'
					});
					$('.tagfield .select2-choices').addClass('ui-corner-all');
				}
			});
		});
	}

	/////
	// Autocomplete
	/////
	$('.ui-autocomplete').removeClass('ui-corner-all');

	/////
	// Catcomplete autocomplete quicksearch
	/////
	$.widget("custom.catcomplete", $.ui.autocomplete, {
		_renderMenu: function(ul,items){
	    	var self = this,
	    	currentCategory = "";
	    	$.each( items, function(index,item){
	    		ul.addClass('catcomplete');
	    		if(item.category != currentCategory){
	    			ul.append( "<li class='ui-autocomplete-category'>" + item.category + "</li>" );
	    			currentCategory = item.category;
	    		}
	    		self._renderItem(ul,item);
	    	});
	    }
	});
	$('#search').catcomplete({
	    source: function(request,response){
	    	$.ajax({
	    		url: gsPath+"index.php?p=jajax&t=search&q="+encodeURIComponent(request.term),
	    		dataType: "json",
	    		success: function(data){response($.map(data,function(item){ return item }))}
	    	})
	    },
	    delay:50,
	    minLength: 3,
		autoFocus: true,
	    open: function(e, ui){
			$('ul.ui-autocomplete li a').each(function(){
				var htmlString = $(this).html().replace(/&lt;/g, '<');
				htmlString = htmlString.replace(/&gt;/g, '>');
				$(this).html(htmlString);
			});
		},
	    select: function(e,selectedItem){
	    	e.preventDefault();
	    	var selectedLink = '';
	    	$.each( selectedItem, function(index,item){ selectedLink = item.link; });
	    	if(selectedLink != ''){
				$('#mainSearch form').attr('action',selectedLink).submit();
	    	}
		},
		close: function(e,selectedItem){
			$(window).unbind('beforeunload');
			if(e.keyCode == 27) $('#search').val('').blur();
		},
		focus: function(e,selectedItem){
			e.preventDefault();
		}			    
	});
	$('#search').keypress(function(e){
		if(e.keyCode == 13) return false;
	});

	/////
	// Navigation Toggle
	/////
	$('#navigation li.sub').prepend('<a class="arrow" title="">+</a>');
	$('#navigation li.subOpen').prepend('<a class="arrow" title="">+</a>');
	$('#navigation li a.arrow').click(function(){
		$(this).parent().toggleClass('sub');
		$(this).parent().toggleClass('subOpen');
		if ($(this).parent().hasClass('sub')) saveHideShowStatus($(this).parent().attr('id'),true);
		if ($(this).parent().hasClass('subOpen')) saveHideShowStatus($(this).parent().attr('id'),false);
		return false;
	});

	/////
	// View Toggle
	/////
	$('#showViews').click(function(){
		$(this).hide();
		$('#views').show();
		saveHideShowStatus($('#identShowHide').html(),false);
	});
	$('#hideViews').click(function(){
		$('#views').hide();
		$('#showViews').show();
		saveHideShowStatus($('#identShowHide').html(),true);
	});

	/////
	// "NEW" Navigation
	/////
	$('#headerL #newActive').mouseenter(function(){
		$('#headerL #newActive').hide();
		$('#headerL #newPane').show();
	});
	$('#headerL #newPane').mouseleave(function(){
		$('#headerL #newPane').hide();
		$('#headerL #newActive').show();
	});
	$('#headerR #favActive').mouseenter(function(){
		$('#headerR #favActive').hide();
		$('#headerR #favPane').show();
	});
	$('#headerR #favPane').mouseleave(function(){
		$('#headerR #favPane').hide();
		$('#headerR #favActive').show();
	});

	/////
	// Sortables Homescreen
	/////
	$("#leftCol").sortable({
		connectWith: '.startColumn',
		handle: 'div.portlet-header',
		update: function(e, ui){
			saveDashboard('left', $('#leftCol').sortable('toArray'));
		}
	});	
	$("#rightCol").sortable({
		connectWith: '.startColumn',
		handle: 'div.portlet-header',
		update: function(e, ui){
			saveDashboard('right', $('#rightCol').sortable('toArray'));
		}
	});	
	$(".portlet").addClass("ui-widget ui-widget-content ui-helper-clearfix ui-corner-all")
		.find(".portlet-header")
			.addClass("ui-widget-header ui-corner-all")
			.prepend('<span class="ui-icon ui-icon-minusthick"></span>')
			.end()
		.find(".portlet-content");
	$(".portlet-header .ui-icon").click(function(){
		$(this).toggleClass("ui-icon-minusthick").toggleClass("ui-icon-plusthick");
		$(this).parents(".portlet:first").find(".portlet-content").toggle();
	});
	$('.portletHide .portlet-header .ui-icon').toggleClass('ui-icon-minusthick ui-icon-plusthick');
	
	/////
	// Portlets Homescreen
	/////
	$('.startColumn .portlet').each(function(){
		var portletRef = $(this);
		var portletId = $(this).attr('id');
		$('.portlet-header .ui-icon',this).click(function(){
			var portletVisible = $('.portlet-content',portletRef).is(':visible');
			saveDashboardStatus(portletId, portletVisible);
		});
	});
		
	/////
	// Form Change Before Unload
	/////
	$('form :input').not('.dataCheck').change(function(){
		$(window).bind('beforeunload', function(e){
			if(typeof(e) != 'undefined'){
				e.preventDefault();
				e.originalEvent.returnValue = "Die durchgeführten Änderungen werden verworfen!";
			}
		});
	});
	$('form').submit(function(){
		$(window).unbind('beforeunload');
	});

	/////
	// Tooltips (http://craigsworks.com/projects/qtip/docs/)
	/////
	$('.tip').qtip({
		show: { delay: 0, effect: {length: 0} },
		hide: { delay: 0, effect: {length: 0} },
		position: {	adjust: { screen: true } },
		style: { 
			tip: { corner: 'topLeft', size: { x: 7, y: 4 } },
			border: { color: '#717171' },
			background: '#717171',
			color: 'white',
			padding: 5
		}
	});

	$('.tipAjax').each(function(){
		$(this).qtip({
			content: {
					text: 'Laden…',
					url: $(this).attr('rel')
			},
			position: {
				adjust: {screen:true}
			},
			show: { 
				when: 'click', 
				solo: true
			},
			hide: 'unfocus',
				style: {
				tip: true,
				border: {
					width: 0,
					radius: 4
				},
				name: 'light',
				width: 600
			}
		})
	}).click(function(e){
		e.preventDefault();
	});
	
	/////
	// Confirm Dialog
	/////
	$.extend($.ui.dialog.prototype.options, {
		position: 'center',
		resizable: false,
		modal: true,
		autoOpen: false,
		draggable: false
	});
	$("#dialog-confirm").dialog({
		title: 'Aktion bestätigen',
		width: 250,
		close: function(){
			$("#dialog-confirm").empty();
		}
	});
	bindConfirmEvent();
	
	/////
	// Rebind event on ajax success
	/////
	$('body').bind('gsalesAjaxSuccess', function(e){
		bindConfirmEvent();
		bindMiteBulkSelect();
		$('textarea').autosize({className:'mirroredText'});
		$('.datePicker').datepicker({
			currentText: 'heute',
			weekHeader: 'W',
			nextText: 'später',
			prevText: 'früher',
			dayNames: ['Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag'],
			dayNamesMin: ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'],
			dayNamesShort: ['Son', 'Mon', 'Die', 'Mit', 'Don', 'Fre', 'Sam'],
			monthNames: ['Januar','Februar','März','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember'],
			monthNamesShort: ['Jan','Feb','Mär','Apr','Mai','Jun','Jul','Aug','Sep','Okt','Nov','Dez'],
			firstDay: 1,
			showOn: 'button',
			buttonImageOnly: true,
			buttonImage: gsPath+'lib/img/icon_calendar.gif',
			dateFormat: 'dd.mm.yy',
			speed: 'fast'
		});
		$('.dateRange').datepicker({
			currentText: 'heute',
			weekHeader: 'W',
			nextText: 'später',
			prevText: 'früher',
			dayNames: ['Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag'],
			dayNamesMin: ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'],
			dayNamesShort: ['Son', 'Mon', 'Die', 'Mit', 'Don', 'Fre', 'Sam'],
			monthNames: ['Januar','Februar','März','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember'],
			monthNamesShort: ['Jan','Feb','Mär','Apr','Mai','Jun','Jul','Aug','Sep','Okt','Nov','Dez'],
			firstDay: 1,
			beforeShow: customRange,
			showOn: 'button',
			buttonImageOnly: true,
			buttonImage: gsPath+'lib/img/icon_calendar.gif',
			dateFormat: 'dd.mm.yy',
			speed: 'fast'
		});
	});
	
	/////
	// HTML Editor
	/////
	if($('#html-textarea').length > 0){
		var htmlEditor = new wysihtml5.Editor('html-textarea', {
			toolbar: 'html-toolbar',
			parserRules: wysihtml5ParserRules,
			useLineBreaks: false
		});
	}

	/////
	// Textarea Autosize
	/////
	$('textarea').not('#html-textarea').autosize({className:'mirroredText'});

	/////
	// Overviewtable tr click/doubleclick
	/////
	var delay = 200;
	var clicks = 0;
	var timer = null;
	$('table.overview tr').not('.static').has('.dataCheck').click(function(e){
		var refEl = this;

		if(!$(e.target).hasClass('tipAjax')){
			//count clicks
			clicks++;
			// single click
			if(clicks == 1){
				timer = setTimeout(function(){
					// select on checkbox click
					if($(e.target).is('input')){
						var checkVal = $('.dataCheck',refEl).attr('checked');
						bulkSelector($('.dataCheck',refEl).attr('id'),checkVal);
						if(checkVal) $(refEl).addClass('checked');
						else $(refEl).removeClass('checked');
					}
					// select on row click
					if($(e.target).is('td')){
						if($('.dataCheck',refEl).attr('checked')){
						$('.dataCheck',refEl).attr('checked',false);
							bulkSelector($('.dataCheck',refEl).attr('id'),false);
							$(refEl).removeClass('checked');
						} else {
							$('.dataCheck',refEl).attr('checked',true);
							bulkSelector($('.dataCheck',refEl).attr('id'),true);
							$(refEl).addClass('checked');
						}
					}
					// reset counter
					clicks = 0;
				}, delay);
			} else {
				// doubleclick, prevent single-click action
				clearTimeout(timer);
				// show details
				var editUrl = $('.dataView',refEl).attr('href');
				if(editUrl) window.location.href = editUrl;
				// reset counter
				clicks = 0;
			}
		}

	}).dblclick(function(e){
		// prevent system double-click event
		e.preventDefault();
	});

	/////
	// Overviewtable tr hightlight checked rows
	/////
	$('table.overview tr').not('.static').each(function(){
		if($('.dataCheck',this).attr('checked')){
			$(this).addClass('checked');
		}
	});

	/////
	// Overviewtable bulk action submit
	/////
	$('.selectBulkAction').change(function(){
		var refSelect = $(this);
		var selectedRows = $('.bulkSelectedCount',$(this).parents('form:first')).html();
		if(selectedRows > 10){
			$("#dialog-confirm").empty();
			$('#dialog-confirm').append('<p></p>');
			$('#dialog-confirm p').append('<span class="ui-icon ui-icon-alert" style="float: left; margin: 0 7px 20px 0;"></span>');
			$('#dialog-confirm p').append('Soll die gewählte Aktion wirklich auf '+selectedRows+' Datensätze angewendet werden?');
			$("#dialog-confirm").dialog("option", "buttons", {
				"OK": function(){
					$(refSelect).parents('form:first').submit();
					$(this).dialog('close');
				},
				"abbrechen": function(){
					$(this).dialog('close');
				}
			});
			$("#dialog-confirm").dialog({
				title: $('option:selected',refSelect).html(),
				close: function(){
					$(window).unbind('beforeunload');
					$('#dialog-confirm').empty();
					$('option:first',refSelect).attr('selected','selected');
				}
			});
			$('#dialog-confirm').dialog('open');
			removeUiClasses();
		} else {
			$(this).parents('form:first').submit();
		}
	});
	
	/////
	// Tabs
	/////
	$('#container-1').tabs();
	
	/////
	// Sub Newsletter
	/////
	$("#startspoollink").click(function(){
		$("#spool_statusbox").show();
		return false;
	});		
	$("#container2link").click(function(){
		$("#container-2").toggle();
		return false;
	});		
	var $firstlevel = $('#container-1').tabs();
	$('#container-2').tabs();
	
	if (self.document.location.hash == '#customer' || self.document.location.hash == '#manual' || self.document.location.hash == '#csv' ){
		$("#container-2").show();
		// fix firefox selection range issue
		if((self.document.location.hash == '#customer') && (navigator.userAgent.toLowerCase().indexOf('firefox') > -1)) {
			setTimeout(function(){
				$firstlevel.tabs('select',1);
			},999);
		} else {
			$firstlevel.tabs('select',1);
		}
	}

	/////
	// Comments
	/////
	$("#commentForm").hide();
	$("#newComment").click(function(){
		$("#commentForm").toggle();
	});

	/////
	// Datepicker
	/////	
	$('.datePicker').datepicker({
		currentText: 'heute',
		weekHeader: 'W',
		nextText: 'später',
		prevText: 'früher',
		dayNames: ['Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag'],
		dayNamesMin: ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'],
		dayNamesShort: ['Son', 'Mon', 'Die', 'Mit', 'Don', 'Fre', 'Sam'],
		monthNames: ['Januar','Februar','März','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember'],
		monthNamesShort: ['Jan','Feb','Mär','Apr','Mai','Jun','Jul','Aug','Sep','Okt','Nov','Dez'],
		firstDay: 1,
		showOn: 'button',
		buttonImageOnly: true,
		buttonImage: gsPath+'lib/img/icon_calendar.gif',
		dateFormat: 'dd.mm.yy',
		speed: 'fast'
	});
	$('.dateRange').datepicker({
		currentText: 'heute',
		weekHeader: 'W',
		nextText: 'später',
		prevText: 'früher',
		dayNames: ['Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag'],
		dayNamesMin: ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'],
		dayNamesShort: ['Son', 'Mon', 'Die', 'Mit', 'Don', 'Fre', 'Sam'],
		monthNames: ['Januar','Februar','März','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember'],
		monthNamesShort: ['Jan','Feb','Mär','Apr','Mai','Jun','Jul','Aug','Sep','Okt','Nov','Dez'],
		firstDay: 1,
		beforeShow: customRange,
		showOn: 'button',
		buttonImageOnly: true,
		buttonImage: gsPath+'lib/img/icon_calendar.gif',
		dateFormat: 'dd.mm.yy',
		speed: 'fast'
	});
	
	/////
	// Hide Tag Box on outerClick
	/////
	$(document).click(function(e){
		if(!$(e.target).is("body") && !$(e.target).is(".tagBox") && !$(e.target).is(".tagBox *") && !$(e.target).is(".ui-autocomplete *")){
			$(".tagBox").hide();
		}
	});
	
	/////
	// Option Pane
	/////
	$(document).click(function(e){ 
		if(!$(e.target).is("#optPane") && !$(e.target).is("#optPane *")){
			$("#options").hide();
			$("#pane").css("backgroundPosition","0px 0px");
		}
	});
	$("#pane").click(function(e){
		e.stopPropagation();
		$("#options").toggle();
		if($("#pane").css("backgroundPosition") == "0px -30px"){
			$("#pane").css("backgroundPosition", "0px 0px");
		} else {
			$("#pane").css("backgroundPosition", "0px -30px");
		}
		// Oversize page height
		var htmlHeight = $('html').height();
		var requiredHeight = $('#optPane').height() + 175;
		if(requiredHeight > htmlHeight) {
			$('html').css('min-height', (requiredHeight + 'px') );
		}
	});
	
	/////
	// Collapse & Toggle Form Tables
	/////
	$(".collapseForm table.stdForm tr:last").addClass("rowHead");
	$(".collapseForm table.stdForm tr").not(".rowHead").hide();
	$(".collapseForm table.stdForm tr.rowHead").slice(0,3).nextUntil("tr.rowHead").show();
	$(".collapseForm table.stdForm tr").not(".rowHead").each(function(){
		$("td:first",this).css("width","160px");
	});	
	$(".collapseForm table.stdForm tr.rowHead").not(":last").hover(function(){
		$(this).css("cursor","pointer");
	}).click(function(){
		$(this).nextUntil('tr.rowHead').toggle();
	});
	var showHideAll = '<div class="showHideAll"><a href="#" class="showAll" title="alle Felder ausklappen"><span aria-hidden="true" data-icon="&#xe00b;"></span></a><a href="#" class="hideAll" title="alle Felder einklappen"><span aria-hidden="true" data-icon="&#xe00a;"></span></a></div>';
	$(".collapseForm table.stdForm").prepend(showHideAll);
	$(".collapseForm .showAll").click(function(){
		$(".collapseForm table.stdForm tr:hidden").show();
	});
	$(".collapseForm .hideAll").click(function(){
		$(".collapseForm table.stdForm tr:visible").not(".rowHead").hide();
		$(".collapseForm table.stdForm tr.rowHead").slice(0,3).nextUntil("tr.rowHead").show();
	});

	
	
	/////
	// Sendaction Subject toggle
	/////
	$("#sendaction_subject_checkbox").click(function(){
		toggleEnabled("sendaction_subject_checkbox","sendaction_subject_input");
  	});		
	
	/////
	// Edit Customer toggle
	/////
	$("#glob_interval").click(function(){
		toggleEnabled("glob_interval","minterval");
		toggleEnabled("glob_interval","start");
  	});	
	$("#glob_discount").click(function(){
		toggleDisabled("glob_discount","discount");
  	});  	
	$("#glob_i_pre_txt").click(function(){
		toggleDisabled("glob_i_pre_txt","i_pre_txt");
  	});  	
	$("#glob_i_post_txt").click(function(){
		toggleDisabled("glob_i_post_txt","i_post_txt");
  	});  	
	$("#glob_i_payable").click(function(){
		toggleDisabled("glob_i_payable","i_payable");
  	});  	
	$("#glob_i_template").click(function(){
		toggleDisabled("glob_i_template","i_template");
  	});  	
	$("#glob_o_pre_txt").click(function(){
		toggleDisabled("glob_o_pre_txt","o_pre_txt");
  	});  	
	$("#glob_o_post_txt").click(function(){
		toggleDisabled("glob_o_post_txt","o_post_txt");
  	});  	
	$("#glob_o_payable").click(function(){
		toggleDisabled("glob_o_payable","o_payable");
  	});  	
	$("#glob_o_template").click(function(){
		toggleDisabled("glob_o_template","o_template");
  	});
    $("#glob_s_pre_txt").click(function(){
        toggleDisabled("glob_s_pre_txt","s_pre_txt");
    });
    $("#glob_s_post_txt").click(function(){
        toggleDisabled("glob_s_post_txt","s_post_txt");
    });
    $("#glob_s_template").click(function(){
        toggleDisabled("glob_s_template","s_template");
    });
    $("#glob_d_pre_txt").click(function(){
        toggleDisabled("glob_d_pre_txt","d_pre_txt");
    });
    $("#glob_d_post_txt").click(function(){
        toggleDisabled("glob_d_post_txt","d_post_txt");
    });
    $("#glob_d_template").click(function(){
        toggleDisabled("glob_d_template","d_template");
    });
	$("#glob_r_pre_txt").click(function(){
		toggleDisabled("glob_r_pre_txt","r_pre_txt");
  	});  	
	$("#glob_r_post_txt").click(function(){
		toggleDisabled("glob_r_post_txt","r_post_txt");
  	});  	
	$("#glob_r_payable").click(function(){
		toggleDisabled("glob_r_payable","r_payable");
  	});
	$("#glob_r_template").click(function(){
		toggleDisabled("glob_r_template","r_template");
  	});  	
	$("#glob_dunning_term_info").click(function(){
		toggleDisabled("glob_dunning_term_info","dunning_term_info");
  	});  	
	$("#glob_dunning_term_1").click(function(){
		toggleDisabled("glob_dunning_term_1","dunning_term_1");
  	});  	
	$("#glob_dunning_term_2").click(function(){
		toggleDisabled("glob_dunning_term_2","dunning_term_2");
  	});  	
	$("#glob_o_plan").click(function(){
		toggleDisabled("glob_o_plan","o_plan");
  	});  	
	$("#glob_i_plan").click(function(){
		toggleDisabled("glob_i_plan","i_plan");
  	});  	
	$("#glob_m_plan").click(function(){
		toggleDisabled("glob_m_plan","m_plan");
  	});  	
	$("#glob_r_plan").click(function(){
		toggleDisabled("glob_r_plan","r_plan");
  	});
    $("#glob_l_plan").click(function(){
        toggleDisabled("glob_l_plan","l_plan");
    });
    $("#glob_s_plan").click(function(){
        toggleDisabled("glob_s_plan","s_plan");
    });
    $("#glob_d_plan").click(function(){
        toggleDisabled("glob_d_plan","d_plan");
    });

    /////
	// pre/after tax calculator
	/////
	$("table.stdForm").has('.infobrutto').each(function(){
		var ref = $(this);
		$(".bruttonetto",this).click(function(){
			replaceNettoPrice(ref);
		});
		$("input[name='price'],input[name='tax']",this).keyup(function(){
			calcBruttoPrice(ref);
		});
		$("input[name='tax']",this).change(function(){
			calcBruttoPrice(ref);
		});
		$(".infobrutto",this).load(function(){
			calcBruttoPrice(ref);
		});
	});

	/////
	// template editor
	/////
	if($('#code').length > 0){
		var editor = CodeMirror(document.getElementById('code'), {
			lineNumbers: true,
			lineWrapping: true,
			mode: $('#code').data('mode'),
			onCursorActivity: function() {
				editor.setLineClass(hlLine, null, null);
				hlLine = editor.setLineClass(editor.getCursor().line, null, 'activeline');
			}
		});
		var hlLine = editor.setLineClass(0, 'activeline');
		editor.setValue($('#filecontent').text());
		// save button
		$('#code-save').click(function(){
			var customfilename = '';
			if($('#customfilename').length > 0) customfilename = $('#customfilename').val();
			saveCustomFile($('#code-save').data('filename'), customfilename, editor.getValue());
		});
	}

	/////
	// keyboard shortcuts
	/////
	$(document).keyboardShortcut({
		bindings: {
			'ctrl+space': function(){
				setTimeout(function(){ window.scrollTo(0,0); },1);
				$('#mainSearch #search').focus();
			},
			'k': function(){
				window.location.href = gsPath + 'customer/index.php?p=newcustomer'; return false;
			},
			'a': function(){
				window.location.href = gsPath + 'offer/index.php?p=new'; return false;
			},
			's': function(){
				window.location.href = gsPath + 'contract/index.php?p=new'; return false;
			},
			'r': function(){
				window.location.href = gsPath + 'invoice/index.php?p=new'; return false;
			},
			'w': function(){
				window.location.href = gsPath + 'queue/index.php?p=new'; return false;
			},
			'g': function(){
				window.location.href = gsPath + 'refund/index.php?p=new'; return false;
			},
			'b': function(){
				window.location.href = gsPath + 'letter/index.php?p=new'; return false;
			}
		},
		except_in: 'input, select, textarea'
	});
	// shortcode legend
	var shortcodeList = '<table cellpadding="5">' +
		'<tr><td class="center">strg+space</td><td>zur Suche springen</td></tr>' +
		'<tr><td class="center">k</td><td>neuer Kunde</td></tr>' +
		'<tr><td class="center">a</td><td>neues Angebot</td></tr>' +
		'<tr><td class="center">s</td><td>neue Serienvorlage</td></tr>' +
		'<tr><td class="center">r</td><td>neue Rechnung</td></tr>' +
		'<tr><td class="center">w</td><td>Warteschlangeneintrag</td></tr>' +
		'<tr><td class="center">g</td><td>neue Gutschrift</td></tr>' +
		'<tr><td class="center">b</td><td>neues Schreiben/Brief</td></tr>' +
	'</table>';
	$('#shortcodes').attr('title',shortcodeList);

	/////
	// HACK - form class for old markup
	/////
	$(':input[size="40"]').addClass('span3');
	$('.docTableEdit :input[size="40"]').not('.tagfield').removeClass('span3').addClass('input-small');
});

/////
// pre/after tax calculator functions
/////
function getFloatFromInput(name, ref){
	return parseFloat($("input[name='"+name+"']",ref).val().replace(",","."));
}
function getStringFromFloat(flo){
	return flo.toString().replace(".",",");
}
function replaceNettoPrice(ref){
	var tax = getFloatFromInput('tax',ref);
	var price_brutto = getFloatFromInput('price',ref);
	var price = (price_brutto/(100+tax))*100;
	if(price) $("input[name='price']",ref).val(getStringFromFloat(price.toFixed(14)));
	calcBruttoPrice(ref);
}
function calcBruttoPrice(ref){
	var tax = getFloatFromInput('tax',ref);
	var price = getFloatFromInput('price',ref);
	var price_brutto = price+((price/100)*tax);
	if (price_brutto) $('.infobrutto',ref).html('= '+getStringFromFloat(price_brutto.toFixed(2))+'&nbsp;' + currencySymbol + ' brutto');
	else $('.infobrutto',ref).empty();
}

/////
// Bind confirm event
/////
function bindConfirmEvent(){
	$('a.confirm').click(function(e){
		e.preventDefault();
		var href = $(this).attr("href");
		var rel  = $(this).attr("rel");
		$("#dialog-confirm").empty();
		$('#dialog-confirm').append('<p></p>');
		$('#dialog-confirm p').append('<span class="ui-icon ui-icon-alert" style="float: left; margin: 0 7px 20px 0;"></span>');
		$('#dialog-confirm p').append($(this).attr("title")+'?');
		$("#dialog-confirm").dialog("option", "buttons", {
			"OK": function(){
				if(href != '' && href != '#'){
					window.location.href = href;	
				} else if(rel != ''){
					$(this).dialog("close");
					$("#dialog-confirm").empty();
					eval(rel);
				}
			},
			"abbrechen": function(){
				$(this).dialog('close');
			}			
		});
		$('#dialog-confirm').dialog('open');
		removeUiClasses();
	});
}

/////
// Remove UI classes
/////
function removeUiClasses(){
	$('.ui-dialog :input.ui-widget').not('.hide').removeClass();
	$('.ui-dialog button.ui-widget').not('.hide').removeClass();
	$('.ui-dialog button').not('.hide').hover(function(){
		$(this).removeClass('ui-state-hover')
	}).click(function(){
		$(this).removeClass('ui-state-active ui-state-focus');
	}).focus(function(){
		$(this).removeClass('ui-state-active ui-state-focus');
	}).mousedown(function(){
		$(this).removeClass('ui-state-active ui-state-focus');
	}).mouseenter(function(){
		$(this).removeClass('ui-state-active ui-state-focus');
	});
	$('.ui-dialog-buttonset').each(function(){
		$('button',this).addClass('btn btn-info');
		$('button:last',this).removeClass('btn-info');
	});
}

/////
// Dialog form validation
/////
function checkLength(o,n,min,max){
	if(o.val().length > max || o.val().length < min){
		o.addClass('formError');
		return false;
	} else {
		return true;
	}
}

/////
// Show/hide elements
/////
function showElementOnPos(id,pos){
	var xOffset = 20;
	$('#'+id).show();	
	if( ( pos['left']-(-$('#'+id).width()) ) > $(window).width() ){
		xOffset = -$('#'+id).width()-20;
	}
	$('#'+id).css({"left":(pos['left']-(-xOffset))+"px", "top":(pos['top']-18)+"px"});
}
function showElement(id){
	$('#'+id).show();
}
function hideElement(id){
	$('#'+id).hide();
}
function toggleDisabled(checkbox, textarea){
	if($('#'+checkbox).attr('checked')) $('#'+textarea).attr('disabled',true);
    if(!$('#'+checkbox).attr('checked')) $('#'+textarea).removeAttr("disabled");
}
function toggleEnabled(checkbox, textarea){
    if($('#'+checkbox).attr('checked')) $('#'+textarea).removeAttr("disabled");
    if(!$('#'+checkbox).attr('checked')) $('#'+textarea).attr('disabled',true);
}
function toggleCheckbox(ref,e){
	if($(e.target).is('td')){
		if($('input[type=checkbox]',ref).attr('checked')){
			$('input[type=checkbox]',ref).attr('checked',false);
			$(ref).removeClass('checked');
		} else {
			$('input[type=checkbox]',ref).attr('checked',true);
			$(ref).addClass('checked');
			$('input.ep',ref).focus();
		}
	} else if($(e.target).is('input.ep')){
		$('input[type=checkbox]',ref).attr('checked',true);
	}
}

/////
// Spoolbar width
/////
function setSpoolbarWidth(widthpercent){
	$('#progressbar').progressbar({value:parseInt(widthpercent)});
}

/////
// Customize two date pickers to work as a date range
/////
function customRange(input,inst){
	return { minDate: ($(input).hasClass('dTo') ? $('.dFrom',input.form).datepicker('getDate') : null), maxDate: ($(input).hasClass('dFrom') ? $('.dTo',input.form).datepicker('getDate') : null) };
}

/////
// Format numbers
/////
function deNumFormat(val){
	return numFormat(val,2,',','.');
}
function numFormat(n,s,d,t){
	n=n.toFixed(s);	
	z=n.split('.');
	g=z[0].split('').reverse();
	g=g.join('');
	s='';
	for (var i=1;i<=g.length;i++){
		s+=g.charAt(i-1);
		if(i%3==0&&i!=g.length)s+=t;
	}
	g=s.split('').reverse();
	de='';
	if(z[1])de=d+z[1];
	g=g.join('')+de;
	return g;
}

/////
// mite bulk select
/////
function bindMiteBulkSelect(){
	$('#mite_entries_list table.overview .miteEntriesAll').click(function(e){
	    e.preventDefault();
	    $('#mite_entries_list table.overview input[type="checkbox"]').attr('checked',true);
		$('#mite_entries_list table.overview tr').addClass('checked');
	});
	$('#mite_entries_list table.overview .miteEntriesNone').click(function(e){
	    e.preventDefault();
	    $('#mite_entries_list table.overview input[type="checkbox"]').attr('checked',false);
	    $('#mite_entries_list table.overview tr').removeClass('checked');
	});
}

/////
// Stat tooltips
/////
function showChartTooltip(x, y, contents){
	$('<div id="chartTooltip">' + contents + '</div>').css({
		position: 'absolute',
		display: 'none',
		top: y + 5,
		left: x + 15,
		border: '1px solid #bfbfbf',
		padding: '2px',
		'background-color': '#fff5c6',
		opacity: 1
	}).appendTo('body').show();
}
function bindTooltip(refChart){
	$(refChart).bind('plothover', function(event, pos, item){
		if(item){
	    	$('#chartTooltip').remove();
	    	var x = item.datapoint[0].toFixed(2),
	    	y = item.datapoint[1].toFixed(2);
	    	var caption;
	    	if(item.datapoint[2] != null){
	    		caption = deNumFormat(item.datapoint[1]-item.datapoint[2])+'&nbsp;'+currencySymbol;
	    	} else {
	    		caption = item.datapoint[1]+'&nbsp;Stück';
	    	}
	    	showChartTooltip(item.pageX,item.pageY,caption);
	    } else {
	    	$('#chartTooltip').remove();
	    }
	});
}


/////
// ajax stuff (xajax replacement)
/////

function overviewTableHideAllFilters(id){
    hideElement('txtfiltercontainer_'+id);
    hideElement('intfiltercontainer_'+id);
    hideElement('datefiltercontainer_'+id);
    hideElement('activefiltercontainer_'+id);
    hideElement('statusinvoicefiltercontainer_'+id);
    hideElement('lastschriftfiltercontainer_'+id);
    hideElement('statusofferfiltercontainer_'+id);
    hideElement('statussalefiltercontainer_'+id);
    hideElement('statusletterfiltercontainer_'+id);
    hideElement('statusmailspoolfiltercontainer_'+id);
    hideElement('statusqueuefiltercontainer_'+id);
    hideElement('statusyesnofiltercontainer_'+id);
    hideElement('statususerfiltercontainer_'+id);
    hideElement('sepatypefiltercontainer_'+id);
}

function deleteFavorite(id){
    $.ajax({
        url: gsPath+'ajx/index.php?p=deletefavorite',
        dataType: 'text',
        data: {favid: id},
        success: function(data){
            if (data == "1") window.location.reload();
        }
    });
}

function saveFavorite(title, url){
    $.ajax({
        url: gsPath+'ajx/index.php?p=savefavorite',
        type: 'POST',
        dataType: 'text',
        data: {title: title, url: url},
        success: function(data){
            favoritesViewUpdate(url, title);
        }
    });
}

function favoritesViewUpdate(url){
    $.ajax({
        url: gsPath+'ajx/index.php?p=favoritesview',
        type: 'POST',
        dataType: 'json',
        data: {curpage: url},
        success: function(data){
            $('#favAddLink').html(data.favAddLink);
            $('#userFavs').html(data.userFavs);
        }
    });
}

function saveDashboard(side, data){
    $.ajax({
        url: gsPath+'ajx/index.php?p=savedashboard',
        type: 'POST',
        dataType: 'json',
        data: {side: side, data:data},
        success: function(data){
        }
    });
}

function saveDashboardStatus(id, status){
    $.ajax({
        url: gsPath+'ajx/index.php?p=savedashboardstatus',
        type: 'POST',
        dataType: 'json',
        data: {id: id, status:status},
        success: function(data){
        }
    });
}

function bulkSelector(field, checked){

    if (checked == 'checked') checked = true;
    if (checked == undefined) checked = false;

    $.ajax({
        url: gsPath+'ajx/index.php?p=bulkselector',
        type: 'POST',
        dataType: 'json',
        data: {field: field, checked:checked},
        success: function(data){
            $('#'+data.element).html(data.value);
        }
    });
}

function prepareFilter(field, type, oid){
    overviewTableHideAllFilters(oid);
    switch (type){
        case 'int': $('#'+'intvfilter_'+oid).val(field); showElement('intfiltercontainer_'+oid);
            break;
        case 'txt': $('#'+'txtvfilter_'+oid).val(field); showElement('txtfiltercontainer_'+oid);
            break;
        case 'active': $('#'+'activevfilter_'+oid).val(field); showElement('activefiltercontainer_'+oid);
            break;
        case 'statusinvoice': $('#'+'statusinvoicevfilter_'+oid).val(field); showElement('statusinvoicefiltercontainer_'+oid);
            break;
        case 'lastschrift': $('#'+'lastschriftvfilter_'+oid).val(field); showElement('lastschriftfiltercontainer_'+oid);
            break;
        case 'statusoffer': $('#'+'statusoffervfilter_'+oid).val(field); showElement('statusofferfiltercontainer_'+oid);
            break;
        case 'statussale': $('#'+'statussalevfilter_'+oid).val(field); showElement('statussalefiltercontainer_'+oid);
            break;
        case 'statusletter': $('#'+'statuslettervfilter_'+oid).val(field); showElement('statusletterfiltercontainer_'+oid);
            break;
        case 'statusmailspool': $('#'+'statusmailspoolvfilter_'+oid).val(field); showElement('statusmailspoolfiltercontainer_'+oid);
            break;
        case 'statusqueue': $('#'+'statusqueuevfilter_'+oid).val(field); showElement('statusqueuefiltercontainer_'+oid);
            break;
        case 'statusyesno': $('#'+'statusyesnovfilter_'+oid).val(field); showElement('statusyesnofiltercontainer_'+oid);
            break;
        case 'statususer': $('#'+'statususervfilter_'+oid).val(field); showElement('statususerfiltercontainer_'+oid);
            break;
        case 'sepatype': $('#'+'sepatypevfilter_'+oid).val(field); showElement('sepatypefiltercontainer_'+oid);
            break;
        case 'date': $('#'+'datevfilter_'+oid).val(field); showElement('datefiltercontainer_'+oid);
            break;
    }
}

function deleteNote(id){
    $.ajax({
        url: gsPath+'ajx/index.php?p=deletenote',
        dataType: 'text',
        data: {noteid: id},
        success: function(data){
            if (data == "1") updateNoteList();
        }
    });
}

function updateNoteList(){
    $.ajax({
        url: gsPath+'ajx/index.php?p=updatenotesview',
        dataType: 'json',
        success: function(data){
            $('#notesList').html(data.notesList);
        }
    });
}

function editNote(noteid, note){
    $.ajax({
        url: gsPath+'ajx/index.php?p=editnote',
        type: 'POST',
        dataType: 'text',
        data: {noteid: noteid, note:note},
        success: function(data){
            if (data == "1") updateNoteList();
        }
    });
}

function prepareEditNote(noteid){
    $.ajax({
        url: gsPath+'ajx/index.php?p=prepareeditnote',
        dataType: 'json',
        data: {noteid: noteid},
        success: function(data){
            $('#note'+noteid).html(data.note);
        }
    });
}

function deleteView(overviewid, id){
    $.ajax({
        url: gsPath+'ajx/index.php?p=deleteview',
        type: 'POST',
        dataType: 'text',
        data: {overviewid: overviewid, id:id},
        success: function(data){
            if (data == "1") updateAvailableViews(overviewid);
        }
    });
}

function updateAvailableViews(overviewid){
    $.ajax({
        url: gsPath+'ajx/index.php?p=updateviewsview',
        type: 'POST',
        dataType: 'json',
        data: {overviewid: overviewid},
        success: function(data){
            $('#view_'+overviewid).html(data.view);
        }
    });
}

function setViewAsDefault(overviewid, id){
    $.ajax({
        url: gsPath+'ajx/index.php?p=setviewasdefault',
        type: 'POST',
        dataType: 'text',
        data: {overviewid: overviewid, id:id},
        success: function(data){
            if (data == "1") updateAvailableViews(overviewid);
        }
    });
}

function saveView(dbtable, viewname, priv){
    $.ajax({
        url: gsPath+'ajx/index.php?p=saveview',
        type: 'POST',
        dataType: 'text',
        data: {dbtable: dbtable, viewname:viewname, priv:priv},
        success: function(data){
            if (data == "1") updateAvailableViews(dbtable);
        }
    });
}

function saveInvoiceItemsList(iid, sort, section){
    $.ajax({
        url: gsPath+'ajx/index.php?p=saveinvoiceitemlist',
        type: 'POST',
        dataType: 'text',
        data: {iid: iid, sort:sort, section:section},
        success: function(data){
        }
    });
}

function saveHideShowStatus(strBlockId, booHide){
    $.ajax({
        url: gsPath+'ajx/index.php?p=savehideshowstatus',
        type: 'POST',
        dataType: 'text',
        data: {blockid: strBlockId, hide:booHide},
        success: function(data){
        }
    });
}

function deleteAttachment(id, istmp){
    $.ajax({
        url: gsPath+'ajx/index.php?p=deleteattachment',
        dataType: 'text',
        data: {id: id, usetmp:istmp},
        success: function(data){
            if (data == "1") hideElement('fileup'+id);
        }
    });
}

function prepareTagging(id, dbtable, overviewId, position){
	$('#select2-drop-mask').remove();
    $.ajax({
        url: gsPath+'ajx/index.php?p=preparetagging',
        type: 'POST',
        dataType: 'json',
        data: { id: id, dbtable: dbtable },
        success: function(data){
			var el = $('#t_tags_'+overviewId);
			$('#t_object_'+overviewId).val(id); // set form id
            if (data.tags) el.val(data.tags);
            else el.val('');
			$.ajax({
				url: gsPath+'ajx/index.php?p=taglist',
				type: 'POST',
				dataType: 'json',
				data: {id: id, dbtable:dbtable},
				success: function(data){
					var taglist = data.tags.split(',');
					el.select2({
						tags: taglist,
						tokenSeparators: [',', ' ']
					});

					showElementOnPos('tagformcontainer_'+overviewId, position);
				}
			});
        }
    });
}

function dunningAction(invoiceid, actionid){
    $.ajax({
        url: gsPath+'ajx/index.php?p=dunningaction',
        type: 'POST',
        dataType: 'text',
        data: { invoiceid: invoiceid, actionid: actionid},
        success: function(data){
			if(data == '0'){
				$('#flag'+invoiceid+actionid).html('<span aria-hidden="true" data-icon="&#xe023;" class="inactive"></span>');
			} else if (data == '1'){
                $('#flag'+invoiceid+'0').html('<span aria-hidden="true" data-icon="&#xe023;" class="inactive"></span>');
                $('#flag'+invoiceid+'1').html('<span aria-hidden="true" data-icon="&#xe023;" class="inactive"></span>');
                $('#flag'+invoiceid+'2').html('<span aria-hidden="true" data-icon="&#xe023;" class="inactive"></span>');
                $('#flag'+invoiceid+'3').html('<span aria-hidden="true" data-icon="&#xe023;" class="inactive"></span>');
                $('#flag'+invoiceid+actionid).html('<span aria-hidden="true" data-icon="&#xe023;"></span>');
            }
        }
    });
}

function saveNewTags(dbtable, overviewid, hidetagcount){
    var t_object = $('#t_object_'+overviewid).val();
    var t_tags = $('#t_tags_'+overviewid).val().replace( new RegExp("\\,","gm")," ");
    $.ajax({
        url: gsPath+'ajx/index.php?p=savenewtags',
        type: 'POST',
        dataType: 'json',
        data: {t_object: t_object, t_tags:t_tags, dbtable:dbtable, overviewid:overviewid, hidetagcount:hidetagcount},
        success: function(data){
            $('#tags_'+overviewid).html(data.tags);
            hideElement('tagformcontainer_'+overviewid);
        }
    });
}

function starHistory(status, id, classname){
    $.ajax({
        url: gsPath+'ajx/index.php?p=starhistory',
        type: 'POST',
        dataType: 'json',
        data: {id: id, classname:classname, status:status},
        success: function(data){
            $('#history_'+id).html(data.star);
        }
    });
}

function starComment(status, id, classname){
    $.ajax({
        url: gsPath+'ajx/index.php?p=starcomment',
        type: 'POST',
        dataType: 'json',
        data: {id: id, classname:classname, status:status},
        success: function(data){
            $('#comment_'+id).html(data.comment);
        }
    });
}

function spoolNewsletter(newsletterid, currpos, total){

    if (currpos == 'undefined') currpos = 0;
    if (total == 'undefined') total = 0;

    $.ajax({
        url: gsPath+'ajx/index.php?p=spoolnewsletter',
        type: 'POST',
        dataType: 'json',
        data: {newsletterid: newsletterid, currpos:currpos, total:total},
        success: function(data){
            if (data.domore == 1){
                $('#spool_statustxt').html(data.percent+'% '+data.currpos+'/'+data.total+')');
                setSpoolbarWidth(data.percent);
                spoolNewsletter(newsletterid, data.currpos, data.total);
            } else {
                window.location.href = 'index.php?p=editnewsletter&nid='+newsletterid+'&anchor=rec';
            }
        }
    });
}

function showMiteDropDown(type){
    $.ajax({
        url: gsPath+'ajx/index.php?p=mitedropdown',
        type: 'POST',
        dataType: 'json',
        data: {type: type},
        success: function(data){
            $('#dropdown_'+type).html(data.dropdown);
        }
    });
}

function showMiteEntries(formid){
    var data = $('#'+formid).serializeArray()
    $.ajax({
        url: gsPath+'ajx/index.php?p=miteentries',
        type: 'POST',
        dataType: 'json',
        data: {data: data},
        success: function(data){
            $('#mite_entries_content').html(data.mite);
        }
    });
}

function googlePDFCloudprint(gsShowFileUrl, title){
    $.ajax({
        url: gsShowFileUrl,
        type: 'POST',
        dataType: 'text',
        data: {base64: 1},
        success: function(data){
            var gadget = new cloudprint.Gadget();
            gadget.setPrintDocument("application/pdf", title, data, 'base64');
            gadget.openPrintDialog();
        }
    });
}

function saveCustomFile(strFileName, strCustomFileName, strFileContent){
    var strFileEscaped = String(strFileContent).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
    $.ajax({
        url: gsPath+'ajx/index.php?p=savecustomfile',
        type: 'POST',
        dataType: 'json',
        data: {strFileName: strFileName, strCustomFileName: strCustomFileName, strFileContent: strFileEscaped},
        success: function(data){
            if (data.status != 0) window.location.href = gsPath + 'admin/index.php?p=editor&file='+data.status;
        }
    });
}

function setSelectCaption(refEl, caption){
	$('.select2-choice span', refEl.prev()).text(caption);
}

function setSelectSearchCaption(refEl, caption){
	if($("input[name='customers_id']").val() != '' && caption != ''){
		caption = $("<div/>").html(caption).text(); // html entity decode string
		refEl.select2('data', { id: $("input[name='customers_id']").val(), text: caption });
	}
}